﻿using System;
using System.Linq;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using MySql.Data.MySqlClient;

namespace TechNote31_MySQLClient_CS
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }

        // 데이터 베이스 객체 선언 CCEADODOTNET.cs 클래스를 참조하세요.
        private CCEADODOTNET m_CEDataBase;

        private MySqlConnection conn;
        private MySqlCommand cmd;
        private IAsyncResult asyncResult;

        private void Form1_Load(object sender, EventArgs e)
        {
            // 현재 Form을 MainForm으로 설정합니다.
            smartForm1.MainForm = this;

            // 데이터베이스 처리 객체 생성
            m_CEDataBase = new CCEADODOTNET();

            // 데이터베이스 연결
            m_CEDataBase.Connection("192.168.1.36", "test_db", "smartx", "12345");

            // SmartListBox Column 설정
            SmartX.SmartListBox.COLUMNSTYLE[] sColumnStyle = new SmartX.SmartListBox.COLUMNSTYLE[5];

            sColumnStyle[0].iColumnWidth = 71;
            sColumnStyle[0].eColumnAlign = SmartX.SmartListBox.COLUMNALIGNS.CENTER;
            sColumnStyle[0].iOffsetColumn = 0;
            sColumnStyle[0].ColumnNameMapping = "NAME";

            sColumnStyle[1].iColumnWidth = 69;
            sColumnStyle[1].eColumnAlign = SmartX.SmartListBox.COLUMNALIGNS.CENTER;
            sColumnStyle[1].iOffsetColumn = 0;
            sColumnStyle[1].ColumnNameMapping = "AGE";

            sColumnStyle[2].iColumnWidth = 116;
            sColumnStyle[2].eColumnAlign = SmartX.SmartListBox.COLUMNALIGNS.CENTER;
            sColumnStyle[2].iOffsetColumn = 0;
            sColumnStyle[2].ColumnNameMapping = "POSITION";

            sColumnStyle[3].iColumnWidth = 126;
            sColumnStyle[3].eColumnAlign = SmartX.SmartListBox.COLUMNALIGNS.CENTER;
            sColumnStyle[3].iOffsetColumn = 0;
            sColumnStyle[3].ColumnNameMapping = "PART";

            sColumnStyle[4].iColumnWidth = 322;
            sColumnStyle[4].eColumnAlign = SmartX.SmartListBox.COLUMNALIGNS.CENTER;
            sColumnStyle[4].iOffsetColumn = 0;
            sColumnStyle[4].ColumnNameMapping = "ENTERING";

            lstDataList.ColumnStyles = sColumnStyle;
        }

        // 사원 정보 데이터 베이스 추가
        private void btnAddData_Click(object sender, EventArgs e)
        {
            Employee emp;
            emp.strName = labName.Text;
            emp.strPart = labPart.Text;
            emp.strPosition = labPosition.Text;
            emp.iAge = Convert.ToInt32(labAge.Text);
            emp.dDatetime = DateTime.Now;

            // 입력된 사원 기본 정보를 저장합니다.
            if (m_CEDataBase.AddData(emp) == true)
            {
                SmartX.SmartMessageBox.Show("사원 정보 입력 성공");
            }
            else
            {
                SmartX.SmartMessageBox.Show("사원 정보 입력 실패");
            }
        }

        // 사원 정보 검색 (검색기준은 이름으로 검색하며 * 입력시 모든 사원 정보를 리스트에 출력합니다.)
        private void btnSearch_Click(object sender, EventArgs e)
        {
            // 입력된 이름의 사원 정보를 읽어와 DataSet에 저장합니다.
            DataSet ds = m_CEDataBase.SearchData(labSearchName.Text);

            // 현재의 SmartListBox 데이터를 모두 지움
            lstDataList.ClearAll();

            // 읽어들인 사원 정보를 SmartListBox에 출력합니다.
            lstDataList.DataSource = ds.Tables[0];
        }

        // 입력된 이름의 사원 정보를 삭제합니다.
        private void btnDeleate_Click(object sender, EventArgs e)
        {
            if (m_CEDataBase.DeleteData(labDeleteName.Text) == true)
            {
                SmartX.SmartMessageBox.Show("사원 정보 삭제 성공");
            }
            else
            {
                SmartX.SmartMessageBox.Show("사원 정보 삭제 실패");
            }
        }

        private void btnNow_Click(object sender, EventArgs e)
        {
            labEntering.Text = DateTime.Now.ToString("yyyy-MM-dd HH:mm:sss");
        }

        private void lstDataList_SelectedIndexChanged(object sender, EventArgs e)
        {
            string strSelect = lstDataList.Items[lstDataList.SelectItemIndex];
            string[] result = new string[5];
            result = strSelect.Split('\n');

            labName.Text = result[0];
            labAge.Text = result[1];
            labPosition.Text = result[2];
            labPart.Text = result[3];
            labEntering.Text = result[4];
            labDeleteName.Text = result[0];
        }

        private void SmartLabel_Click(object sender, EventArgs e)
        {
            smartKeyboard1.KeyboardType = SmartX.SmartKeyboard.KEYBOARDTYPES.NORMAL;
            smartKeyboard1.SizeRunTime = new Size(559, 222);

            if (sender == labName)
            {
                smartKeyboard1.Show(90, 110, labName);
            }
            else if (sender == labDeleteName)
            {
                smartKeyboard1.Show(90, 206, labDeleteName);
            }
            else if (sender == labPosition)
            {
                smartKeyboard1.Show(90, 110, labPosition);
            }
            else if (sender == labPart)
            {
                smartKeyboard1.Show(90, 144, labPart);
            }
            else if (sender == labSearchName)
            {
                smartKeyboard1.Show(90, 206, labSearchName);
            }
            else
            {
                smartKeyboard1.KeyboardType = SmartX.SmartKeyboard.KEYBOARDTYPES.NUMERICAL;
                smartKeyboard1.SizeRunTime = new Size(200, 200);
                smartKeyboard1.Show(414, 110, labAge);
            }
        }
    }
}