﻿Imports TechNote31_MySQLClient_VB.TechNote31_MySQLClient_VB
Imports System.Data
Imports MySql.Data.MySqlClient

Public Class Form1

    ' 데이터 베이스 객체 선언 CCEADODOTNET.cs 클래스를 참조하세요.
    Private m_CEDataBase As CCEADODOTNET

    Private conn As MySqlConnection
    Private cmd As MySqlCommand
    Private asyncResult As IAsyncResult

    Private Sub Form1_Load(ByVal sender As Object, ByVal e As EventArgs) Handles MyBase.Load
        ' 현재 Form을 MainForm으로 설정합니다.
        SmartForm1.MainForm = Me

        ' 데이터베이스 처리 객체 생성
        m_CEDataBase = New CCEADODOTNET()

        ' 데이터베이스 연결
        m_CEDataBase.Connection("192.168.1.36", "test_db", "smartx", "12345")

        ' SmartListBox Column 설정
        Dim sColumnStyle As SmartX.SmartListBox.COLUMNSTYLE() = New SmartX.SmartListBox.COLUMNSTYLE(4) {}
        sColumnStyle(0).iColumnWidth = 71
        sColumnStyle(0).eColumnAlign = SmartX.SmartListBox.COLUMNALIGNS.CENTER
        sColumnStyle(0).iOffsetColumn = 0
        sColumnStyle(0).ColumnNameMapping = "NAME"

        sColumnStyle(1).iColumnWidth = 69
        sColumnStyle(1).eColumnAlign = SmartX.SmartListBox.COLUMNALIGNS.CENTER
        sColumnStyle(1).iOffsetColumn = 0
        sColumnStyle(1).ColumnNameMapping = "AGE"

        sColumnStyle(2).iColumnWidth = 116
        sColumnStyle(2).eColumnAlign = SmartX.SmartListBox.COLUMNALIGNS.CENTER
        sColumnStyle(2).iOffsetColumn = 0
        sColumnStyle(2).ColumnNameMapping = "POSITION"

        sColumnStyle(3).iColumnWidth = 126
        sColumnStyle(3).eColumnAlign = SmartX.SmartListBox.COLUMNALIGNS.CENTER
        sColumnStyle(3).iOffsetColumn = 0
        sColumnStyle(3).ColumnNameMapping = "PART"

        sColumnStyle(4).iColumnWidth = 322
        sColumnStyle(4).eColumnAlign = SmartX.SmartListBox.COLUMNALIGNS.CENTER
        sColumnStyle(4).iOffsetColumn = 0
        sColumnStyle(4).ColumnNameMapping = "ENTERING"

        lstDataList.ColumnStyles = sColumnStyle
    End Sub

    ' 사원 정보 데이터 베이스 추가
    Private Sub btnAddData_Click(ByVal sender As Object, ByVal e As EventArgs) Handles btnAddData.Click
        Dim emp As Employee
        emp.strName = labName.Text
        emp.strPart = labPart.Text
        emp.strPosition = labPosition.Text
        emp.iAge = Convert.ToInt32(labAge.Text)
        emp.dDatetime = DateTime.Now

        ' 입력된 사원 기본 정보를 저장합니다.
        If m_CEDataBase.AddData(emp) = True Then
            SmartX.SmartMessageBox.Show("사원 정보 입력 성공")
        Else
            SmartX.SmartMessageBox.Show("사원 정보 입력 실패")
        End If
    End Sub

    ' 사원 정보 검색 (검색기준은 이름으로 검색하며 * 입력시 모든 사원 정보를 리스트에 출력합니다.)
    Private Sub btnSearch_Click(ByVal sender As Object, ByVal e As EventArgs) Handles btnSearch.Click
        ' 입력된 이름의 사원 정보를 읽어와 DataSet에 저장합니다.
        Dim ds As DataSet = m_CEDataBase.SearchData(labSearchName.Text)

        ' 현재의 SmartListBox 데이터를 모두 지움
        lstDataList.ClearAll()

        ' 읽어들인 사원 정보를 SmartListBox에 출력합니다.
        lstDataList.DataSource = ds.Tables(0)
    End Sub

    ' 입력된 이름의 사원 정보를 삭제합니다.
    Private Sub btnDeleate_Click(ByVal sender As Object, ByVal e As EventArgs) Handles btnDeleate.Click
        If m_CEDataBase.DeleteData(labDeleteName.Text) = True Then
            SmartX.SmartMessageBox.Show("사원 정보 삭제 성공")
        Else
            SmartX.SmartMessageBox.Show("사원 정보 삭제 실패")
        End If
    End Sub

    Private Sub btnNow_Click(ByVal sender As Object, ByVal e As EventArgs) Handles btnNow.Click
        labEntering.Text = DateTime.Now.ToString("yyyy-MM-dd HH:mm:sss")
    End Sub

    Private Sub lstDataList_SelectedIndexChanged(ByVal sender As Object, ByVal e As EventArgs) Handles lstDataList.SelectedIndexChanged
        Dim strSelect As String = lstDataList.Items(lstDataList.SelectItemIndex)
        Dim result As String() = New String(4) {}
        result = strSelect.Split(vbLf)
        labName.Text = result(0)
        labAge.Text = result(1)
        labPosition.Text = result(2)
        labPart.Text = result(3)
        labEntering.Text = result(4)
        labDeleteName.Text = result(0)
    End Sub

    Private Sub SmartLabel_Click(ByVal sender As Object, ByVal e As EventArgs) Handles labSearchName.Click, labPosition.Click, labPart.Click, labName.Click, labDeleteName.Click, labAge.Click
        smartKeyboard1.KeyboardType = SmartX.SmartKeyboard.KEYBOARDTYPES.NORMAL
        smartKeyboard1.SizeRunTime = New Size(559, 222)

        If sender Is labName Then
            smartKeyboard1.Show(90, 110, labName)
        ElseIf sender Is labDeleteName Then
            smartKeyboard1.Show(90, 206, labDeleteName)
        ElseIf sender Is labPosition Then
            smartKeyboard1.Show(90, 110, labPosition)
        ElseIf sender Is labPart Then
            smartKeyboard1.Show(90, 144, labPart)
        ElseIf sender Is labSearchName Then
            smartKeyboard1.Show(90, 206, labSearchName)
        Else
            smartKeyboard1.KeyboardType = SmartX.SmartKeyboard.KEYBOARDTYPES.NUMERICAL
            smartKeyboard1.SizeRunTime = New Size(200, 200)
            smartKeyboard1.Show(414, 110, labAge)
        End If
    End Sub
End Class
